diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitMimeInfo.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitMimeInfo.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitMimeInfo.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitMimeInfo.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -20,12 +20,32 @@
 #include "config.h"
 #include "WebKitMimeInfo.h"
 
+#include "WebKitMimeInfoPrivate.h"
+#include <wtf/glib/GRefPtr.h>
+#include <wtf/text/CString.h>
+
 struct _WebKitMimeInfo {
+    _WebKitMimeInfo(const WebCore::MimeClassInfo& mimeInfo)
+        : mimeInfo(mimeInfo)
+    {
+    }
+
+    WebCore::MimeClassInfo mimeInfo;
+    CString mimeType;
+    CString description;
+    GRefPtr<GPtrArray> extensions;
+
+    int referenceCount { 0 };
 };
 
-ALLOW_DEPRECATED_DECLARATIONS_BEGIN
 G_DEFINE_BOXED_TYPE(WebKitMimeInfo, webkit_mime_info, webkit_mime_info_ref, webkit_mime_info_unref)
-ALLOW_DEPRECATED_DECLARATIONS_END
+
+WebKitMimeInfo* webkitMimeInfoCreate(const WebCore::MimeClassInfo& mimeInfo)
+{
+    WebKitMimeInfo* info = static_cast<WebKitMimeInfo*>(fastMalloc(sizeof(WebKitMimeInfo)));
+    new (info) WebKitMimeInfo(mimeInfo);
+    return info;
+}
 
 /**
  * webkit_mime_info_ref:
@@ -35,12 +55,11 @@ ALLOW_DEPRECATED_DECLARATIONS_END
  * function is MT-safe and may be called from any thread.
  *
  * Returns: The passed in #WebKitMimeInfo
- *
- * Deprecated: 2.32
  */
-WebKitMimeInfo* webkit_mime_info_ref(WebKitMimeInfo*)
+WebKitMimeInfo* webkit_mime_info_ref(WebKitMimeInfo* info)
 {
-    return nullptr;
+    g_atomic_int_inc(&info->referenceCount);
+    return info;
 }
 
 /**
@@ -51,11 +70,13 @@ WebKitMimeInfo* webkit_mime_info_ref(Web
  * reference count drops to 0, all memory allocated by the #WebKitMimeInfo is
  * released. This function is MT-safe and may be called from any
  * thread.
- *
- * Deprecated: 2.32
  */
-void webkit_mime_info_unref(WebKitMimeInfo*)
+void webkit_mime_info_unref(WebKitMimeInfo* info)
 {
+    if (g_atomic_int_dec_and_test(&info->referenceCount)) {
+        info->~WebKitMimeInfo();
+        fastFree(info);
+    }
 }
 
 /**
@@ -63,12 +84,17 @@ void webkit_mime_info_unref(WebKitMimeIn
  * @info: a #WebKitMimeInfo
  *
  * Returns: the MIME type of @info
- *
- * Deprecated: 2.32
  */
-const char* webkit_mime_info_get_mime_type(WebKitMimeInfo*)
+const char* webkit_mime_info_get_mime_type(WebKitMimeInfo* info)
 {
-    return nullptr;
+    if (!info->mimeType.isNull())
+        return info->mimeType.data();
+
+    if (info->mimeInfo.type.isEmpty())
+        return 0;
+
+    info->mimeType = info->mimeInfo.type.utf8();
+    return info->mimeType.data();
 }
 
 /**
@@ -76,12 +102,17 @@ const char* webkit_mime_info_get_mime_ty
  * @info: a #WebKitMimeInfo
  *
  * Returns: the description of the MIME type of @info
- *
- * Deprecated: 2.32
  */
-const char* webkit_mime_info_get_description(WebKitMimeInfo*)
+const char* webkit_mime_info_get_description(WebKitMimeInfo* info)
 {
-    return nullptr;
+    if (!info->description.isNull())
+        return info->description.data();
+
+    if (info->mimeInfo.desc.isEmpty())
+        return 0;
+
+    info->description = info->mimeInfo.desc.utf8();
+    return info->description.data();
 }
 
 /**
@@ -93,10 +124,22 @@ const char* webkit_mime_info_get_descrip
  *
  * Returns: (array zero-terminated=1) (transfer none): a
  *     %NULL-terminated array of strings
- *
- * Deprecated: 2.32
  */
-const char* const* webkit_mime_info_get_extensions(WebKitMimeInfo*)
+const char* const* webkit_mime_info_get_extensions(WebKitMimeInfo* info)
 {
-    return nullptr;
+    if (info->extensions)
+        return reinterpret_cast<gchar**>(info->extensions->pdata);
+
+    if (info->mimeInfo.extensions.isEmpty())
+        return 0;
+
+    info->extensions = adoptGRef(g_ptr_array_new_with_free_func(g_free));
+    for (size_t i = 0; i < info->mimeInfo.extensions.size(); ++i) {
+        if (info->mimeInfo.extensions[i].isEmpty())
+            continue;
+        g_ptr_array_add(info->extensions.get(), g_strdup(info->mimeInfo.extensions[i].utf8().data()));
+    }
+    g_ptr_array_add(info->extensions.get(), 0);
+
+    return reinterpret_cast<gchar**>(info->extensions->pdata);
 }
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitMimeInfoPrivate.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitMimeInfoPrivate.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitMimeInfoPrivate.h	1969-12-31 18:00:00.000000000 -0600
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitMimeInfoPrivate.h	2021-09-29 11:16:12.683267699 -0500
@@ -0,0 +1,25 @@
+/*
+ * Copyright (C) 2012 Igalia S.L.
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+#pragma once
+
+#include "WebKitMimeInfo.h"
+#include <WebCore/PluginData.h>
+
+WebKitMimeInfo* webkitMimeInfoCreate(const WebCore::MimeClassInfo&);
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitPlugin.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitPlugin.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitPlugin.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitPlugin.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -20,7 +20,12 @@
 #include "config.h"
 #include "WebKitPlugin.h"
 
+#include "WebKitMimeInfoPrivate.h"
+#include "WebKitPluginPrivate.h"
 #include <wtf/glib/WTFGType.h>
+#include <wtf/text/CString.h>
+
+using namespace WebKit;
 
 /**
  * SECTION: WebKitPlugin
@@ -34,31 +39,52 @@
  * be obtained from the #WebKitWebContext, with
  * webkit_web_context_get_plugins().
  *
- * Deprecated: 2.32
  */
 
 struct _WebKitPluginPrivate {
+    ~_WebKitPluginPrivate()
+    {
+        g_list_free_full(mimeInfoList, reinterpret_cast<GDestroyNotify>(webkit_mime_info_unref));
+    }
+
+    PluginModuleInfo pluginInfo;
+    CString name;
+    CString description;
+    CString path;
+    GList* mimeInfoList;
 };
 
-ALLOW_DEPRECATED_DECLARATIONS_BEGIN
 WEBKIT_DEFINE_TYPE(WebKitPlugin, webkit_plugin, G_TYPE_OBJECT)
-ALLOW_DEPRECATED_DECLARATIONS_END
 
 static void webkit_plugin_class_init(WebKitPluginClass*)
 {
 }
 
+WebKitPlugin* webkitPluginCreate(const PluginModuleInfo& pluginInfo)
+{
+    WebKitPlugin* plugin = WEBKIT_PLUGIN(g_object_new(WEBKIT_TYPE_PLUGIN, NULL));
+    plugin->priv->pluginInfo = pluginInfo;
+    return plugin;
+}
+
 /**
  * webkit_plugin_get_name:
  * @plugin: a #WebKitPlugin
  *
  * Returns: the name of the plugin.
- *
- * Deprecated: 2.32
  */
-const char* webkit_plugin_get_name(WebKitPlugin*)
+const char* webkit_plugin_get_name(WebKitPlugin* plugin)
 {
-    return nullptr;
+    g_return_val_if_fail(WEBKIT_IS_PLUGIN(plugin), 0);
+
+    if (!plugin->priv->name.isNull())
+        return plugin->priv->name.data();
+
+    if (plugin->priv->pluginInfo.info.name.isEmpty())
+        return 0;
+
+    plugin->priv->name = plugin->priv->pluginInfo.info.name.utf8();
+    return plugin->priv->name.data();
 }
 
 /**
@@ -66,12 +92,19 @@ const char* webkit_plugin_get_name(WebKi
  * @plugin: a #WebKitPlugin
  *
  * Returns: the description of the plugin.
- *
- * Deprecated: 2.32
  */
-const char* webkit_plugin_get_description(WebKitPlugin*)
+const char* webkit_plugin_get_description(WebKitPlugin* plugin)
 {
-    return nullptr;
+    g_return_val_if_fail(WEBKIT_IS_PLUGIN(plugin), 0);
+
+    if (!plugin->priv->description.isNull())
+        return plugin->priv->description.data();
+
+    if (plugin->priv->pluginInfo.info.desc.isEmpty())
+        return 0;
+
+    plugin->priv->description = plugin->priv->pluginInfo.info.desc.utf8();
+    return plugin->priv->description.data();
 }
 
 /**
@@ -79,12 +112,19 @@ const char* webkit_plugin_get_descriptio
  * @plugin: a #WebKitPlugin
  *
  * Returns: the absolute path where the plugin is installed.
- *
- * Deprecated: 2.32
  */
-const char* webkit_plugin_get_path(WebKitPlugin*)
+const char* webkit_plugin_get_path(WebKitPlugin* plugin)
 {
-    return nullptr;
+    g_return_val_if_fail(WEBKIT_IS_PLUGIN(plugin), 0);
+
+    if (!plugin->priv->path.isNull())
+        return plugin->priv->path.data();
+
+    if (plugin->priv->pluginInfo.path.isEmpty())
+        return 0;
+
+    plugin->priv->path = plugin->priv->pluginInfo.path.utf8();
+    return plugin->priv->path.data();
 }
 
 /**
@@ -95,10 +135,18 @@ const char* webkit_plugin_get_path(WebKi
  * as a list of #WebKitMimeInfo.
  *
  * Returns: (element-type WebKitMimeInfo) (transfer none): a #GList of #WebKitMimeInfo.
- *
- * Deprecated: 2.32
  */
-GList* webkit_plugin_get_mime_info_list(WebKitPlugin*)
+GList* webkit_plugin_get_mime_info_list(WebKitPlugin* plugin)
 {
-    return nullptr;
+    g_return_val_if_fail(WEBKIT_IS_PLUGIN(plugin), 0);
+
+    if (plugin->priv->mimeInfoList)
+        return plugin->priv->mimeInfoList;
+
+    if (plugin->priv->pluginInfo.info.mimes.isEmpty())
+        return 0;
+
+    for (size_t i = 0; i < plugin->priv->pluginInfo.info.mimes.size(); ++i)
+        plugin->priv->mimeInfoList = g_list_prepend(plugin->priv->mimeInfoList, webkitMimeInfoCreate(plugin->priv->pluginInfo.info.mimes[i]));
+    return plugin->priv->mimeInfoList;
 }
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitPluginPrivate.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitPluginPrivate.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitPluginPrivate.h	1969-12-31 18:00:00.000000000 -0600
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitPluginPrivate.h	2021-09-29 11:16:12.683267699 -0500
@@ -0,0 +1,25 @@
+/*
+ * Copyright (C) 2012 Igalia S.L.
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+#pragma once
+
+#include "PluginModuleInfo.h"
+#include "WebKitPlugin.h"
+
+WebKitPlugin* webkitPluginCreate(const WebKit::PluginModuleInfo&);
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitSettings.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitSettings.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitSettings.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitSettings.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -228,6 +228,7 @@ static void webKitSettingsSetProperty(GO
         webkit_settings_set_enable_frame_flattening(settings, g_value_get_boolean(value));
         break;
     case PROP_ENABLE_PLUGINS:
+        webkit_settings_set_enable_plugins(settings, g_value_get_boolean(value));
         break;
     case PROP_ENABLE_JAVA:
         webkit_settings_set_enable_java(settings, g_value_get_boolean(value));
@@ -430,7 +431,7 @@ static void webKitSettingsGetProperty(GO
         g_value_set_boolean(value, webkit_settings_get_enable_frame_flattening(settings));
         break;
     case PROP_ENABLE_PLUGINS:
-        g_value_set_boolean(value, FALSE);
+        g_value_set_boolean(value, webkit_settings_get_enable_plugins(settings));
         break;
     case PROP_ENABLE_JAVA:
         g_value_set_boolean(value, webkit_settings_get_enable_java(settings));
@@ -739,7 +740,7 @@ static void webkit_settings_class_init(W
             "enable-plugins",
             _("Enable plugins"),
             _("Enable embedded plugin objects."),
-            FALSE,
+            TRUE,
             readWriteConstructParamFlags);
 
     /**
@@ -1879,16 +1880,12 @@ void webkit_settings_set_enable_frame_fl
  * Get the #WebKitSettings:enable-plugins property.
  *
  * Returns: %TRUE If plugins are enabled or %FALSE otherwise.
- *
- * Deprecated: 2.32
  */
 gboolean webkit_settings_get_enable_plugins(WebKitSettings* settings)
 {
     g_return_val_if_fail(WEBKIT_IS_SETTINGS(settings), FALSE);
 
-    g_warning("webkit_settings_get_enable_plugins is deprecated and always returns FALSE. Plugins are no longer supported.");
-
-    return FALSE;
+    return settings->priv->preferences->pluginsEnabled();
 }
 
 /**
@@ -1897,15 +1894,18 @@ gboolean webkit_settings_get_enable_plug
  * @enabled: Value to be set
  *
  * Set the #WebKitSettings:enable-plugins property.
- *
- * Deprecated: 2.32
  */
 void webkit_settings_set_enable_plugins(WebKitSettings* settings, gboolean enabled)
 {
     g_return_if_fail(WEBKIT_IS_SETTINGS(settings));
 
-    if (enabled)
-        g_warning("webkit_settings_set_enable_plugins is deprecated and does nothing. Plugins are no longer supported.");
+    WebKitSettingsPrivate* priv = settings->priv;
+    bool currentValue = priv->preferences->pluginsEnabled();
+    if (currentValue == enabled)
+        return;
+
+    priv->preferences->setPluginsEnabled(enabled);
+    g_object_notify(G_OBJECT(settings), "enable-plugins");
 }
 
 /**
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebContext.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebContext.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebContext.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebContext.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -42,6 +42,7 @@
 #include "WebKitMemoryPressureSettings.h"
 #include "WebKitMemoryPressureSettingsPrivate.h"
 #include "WebKitNotificationProvider.h"
+#include "WebKitPluginPrivate.h"
 #include "WebKitPrivate.h"
 #include "WebKitProtocolHandler.h"
 #include "WebKitSecurityManagerPrivate.h"
@@ -1147,12 +1148,31 @@ WebKitSecurityManager* webkit_web_contex
  * @directory: the directory to add
  *
  * Set an additional directory where WebKit will look for plugins.
- *
- * Deprecated: 2.32
  */
-void webkit_web_context_set_additional_plugins_directory(WebKitWebContext*, const char*)
+void webkit_web_context_set_additional_plugins_directory(WebKitWebContext* context, const char* directory)
+{
+    g_return_if_fail(WEBKIT_IS_WEB_CONTEXT(context));
+    g_return_if_fail(directory);
+
+#if ENABLE(NETSCAPE_PLUGIN_API)
+    context->priv->processPool->setAdditionalPluginsDirectory(FileSystem::stringFromFileSystemRepresentation(directory));
+#endif
+}
+
+static void destroyPluginList(GList* plugins)
+{
+    g_list_free_full(plugins, g_object_unref);
+}
+
+static void webkitWebContextGetPluginThread(GTask* task, gpointer object, gpointer /* taskData */, GCancellable*)
 {
-    g_warning("webkit_web_context_set_additional_plugins_directory is deprecated and does nothing. Netscape plugins are no longer supported.");
+    GList* returnValue = 0;
+#if ENABLE(NETSCAPE_PLUGIN_API)
+    Vector<PluginModuleInfo> plugins = WEBKIT_WEB_CONTEXT(object)->priv->processPool->pluginInfoStore().plugins();
+    for (size_t i = 0; i < plugins.size(); ++i)
+        returnValue = g_list_prepend(returnValue, webkitPluginCreate(plugins[i]));
+#endif
+    g_task_return_pointer(task, returnValue, reinterpret_cast<GDestroyNotify>(destroyPluginList));
 }
 
 /**
@@ -1166,17 +1186,13 @@ void webkit_web_context_set_additional_p
  *
  * When the operation is finished, @callback will be called. You can then call
  * webkit_web_context_get_plugins_finish() to get the result of the operation.
- *
- * Deprecated: 2.32
  */
 void webkit_web_context_get_plugins(WebKitWebContext* context, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer userData)
 {
     g_return_if_fail(WEBKIT_IS_WEB_CONTEXT(context));
 
-    g_warning("webkit_web_context_get_plugins is deprecated and always returns an empty list. Netscape plugins are no longer supported.");
-
     GRefPtr<GTask> task = adoptGRef(g_task_new(context, cancellable, callback, userData));
-    g_task_return_pointer(task.get(), nullptr, nullptr);
+    g_task_run_in_thread(task.get(), webkitWebContextGetPluginThread);
 }
 
 /**
@@ -1189,13 +1205,11 @@ void webkit_web_context_get_plugins(WebK
  *
  * Returns: (element-type WebKitPlugin) (transfer full): a #GList of #WebKitPlugin. You must free the #GList with
  *    g_list_free() and unref the #WebKitPlugin<!-- -->s with g_object_unref() when you're done with them.
- *
- * Deprecated: 2.32
  */
 GList* webkit_web_context_get_plugins_finish(WebKitWebContext* context, GAsyncResult* result, GError** error)
 {
-    g_return_val_if_fail(WEBKIT_IS_WEB_CONTEXT(context), nullptr);
-    g_return_val_if_fail(g_task_is_valid(result, context), nullptr);
+    g_return_val_if_fail(WEBKIT_IS_WEB_CONTEXT(context), 0);
+    g_return_val_if_fail(g_task_is_valid(result, context), 0);
 
     return static_cast<GList*>(g_task_propagate_pointer(G_TASK(result), error));
 }
@@ -1226,7 +1240,9 @@ GList* webkit_web_context_get_plugins_fi
  *     const gchar  *path;
  *
  *     path = webkit_uri_scheme_request_get_path (request);
- *     if (!g_strcmp0 (path, "memory")) {
+ *     if (!g_strcmp0 (path, "plugins")) {
+ *         /<!-- -->* Create a GInputStream with the contents of plugins about page, and set its length to stream_length *<!-- -->/
+ *     } else if (!g_strcmp0 (path, "memory")) {
  *         /<!-- -->* Create a GInputStream with the contents of memory about page, and set its length to stream_length *<!-- -->/
  *     } else if (!g_strcmp0 (path, "applications")) {
  *         /<!-- -->* Create a GInputStream with the contents of applications about page, and set its length to stream_length *<!-- -->/
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebsiteData.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebsiteData.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebsiteData.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebsiteData.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -74,6 +74,9 @@ static bool recordContainsSupportedDataT
         WebsiteDataType::WebSQLDatabases,
         WebsiteDataType::IndexedDBDatabases,
         WebsiteDataType::HSTSCache,
+#if ENABLE(NETSCAPE_PLUGIN_API)
+        WebsiteDataType::PlugInData,
+#endif
         WebsiteDataType::Cookies,
         WebsiteDataType::DeviceIdHashSalt,
         WebsiteDataType::ResourceLoadStatistics,
@@ -103,6 +106,10 @@ static WebKitWebsiteDataTypes toWebKitWe
         returnValue |= WEBKIT_WEBSITE_DATA_INDEXEDDB_DATABASES;
     if (types.contains(WebsiteDataType::HSTSCache))
         returnValue |= WEBKIT_WEBSITE_DATA_HSTS_CACHE;
+#if ENABLE(NETSCAPE_PLUGIN_API)
+    if (types.contains(WebsiteDataType::PlugInData))
+        returnValue |= WEBKIT_WEBSITE_DATA_PLUGIN_DATA;
+#endif
     if (types.contains(WebsiteDataType::Cookies))
         returnValue |= WEBKIT_WEBSITE_DATA_COOKIES;
     if (types.contains(WebsiteDataType::DeviceIdHashSalt))
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebsiteDataManager.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebsiteDataManager.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebsiteDataManager.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebsiteDataManager.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -993,6 +993,10 @@ static OptionSet<WebsiteDataType> toWebs
         returnValue.add(WebsiteDataType::IndexedDBDatabases);
     if (types & WEBKIT_WEBSITE_DATA_HSTS_CACHE)
         returnValue.add(WebsiteDataType::HSTSCache);
+#if ENABLE(NETSCAPE_PLUGIN_API)
+    if (types & WEBKIT_WEBSITE_DATA_PLUGIN_DATA)
+        returnValue.add(WebsiteDataType::PlugInData);
+#endif
     if (types & WEBKIT_WEBSITE_DATA_COOKIES)
         returnValue.add(WebsiteDataType::Cookies);
     if (types & WEBKIT_WEBSITE_DATA_DEVICE_ID_HASH_SALT)
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebView.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebView.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/glib/WebKitWebView.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/glib/WebKitWebView.cpp	2021-09-29 11:16:12.683267699 -0500
@@ -501,7 +501,8 @@ static gboolean webkitWebViewLoadFail(We
 {
     if (g_error_matches(error, WEBKIT_NETWORK_ERROR, WEBKIT_NETWORK_ERROR_CANCELLED)
         || g_error_matches(error, WEBKIT_PLUGIN_ERROR, WEBKIT_PLUGIN_ERROR_WILL_HANDLE_LOAD)
-        || g_error_matches(error, WEBKIT_POLICY_ERROR, WEBKIT_POLICY_ERROR_FRAME_LOAD_INTERRUPTED_BY_POLICY_CHANGE))
+        || g_error_matches(error, WEBKIT_POLICY_ERROR, WEBKIT_POLICY_ERROR_FRAME_LOAD_INTERRUPTED_BY_POLICY_CHANGE)
+        || g_error_matches(error, WEBKIT_PLUGIN_ERROR, WEBKIT_PLUGIN_ERROR_WILL_HANDLE_LOAD))
         return FALSE;
 
     GUniquePtr<char> htmlString(g_strdup_printf("<html><body>%s</body></html>", error->message));
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitError.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitError.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitError.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitError.h	2021-09-29 11:16:12.683267699 -0500
@@ -41,6 +41,12 @@ G_BEGIN_DECLS
 /**
  * WebKitNetworkError:
  * @WEBKIT_NETWORK_ERROR_FAILED: Generic load failure
+ * @WEBKIT_PLUGIN_ERROR_FAILED: Generic plugin load failure
+ * @WEBKIT_PLUGIN_ERROR_CANNOT_FIND_PLUGIN: Load failure due to missing plugin
+ * @WEBKIT_PLUGIN_ERROR_CANNOT_LOAD_PLUGIN: Load failure due to inability to load plugin
+ * @WEBKIT_PLUGIN_ERROR_JAVA_UNAVAILABLE: Load failure due to missing Java support that is required to load plugin
+ * @WEBKIT_PLUGIN_ERROR_CONNECTION_CANCELLED: Load failure due to connection cancellation
+ * @WEBKIT_PLUGIN_ERROR_WILL_HANDLE_LOAD: Load failure since plugin handles the load
  * @WEBKIT_NETWORK_ERROR_TRANSPORT: Load failure due to transport error
  * @WEBKIT_NETWORK_ERROR_UNKNOWN_PROTOCOL: Load failure due to unknown protocol
  * @WEBKIT_NETWORK_ERROR_CANCELLED: Load failure due to cancellation
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitMimeInfo.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitMimeInfo.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitMimeInfo.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitMimeInfo.h	2021-09-29 11:16:12.683267699 -0500
@@ -34,22 +34,22 @@ G_BEGIN_DECLS
 typedef struct _WebKitMimeInfo WebKitMimeInfo;
 
 
-WEBKIT_DEPRECATED GType
+WEBKIT_API GType
 webkit_mime_info_get_type        (void);
 
-WEBKIT_DEPRECATED WebKitMimeInfo *
+WEBKIT_API WebKitMimeInfo *
 webkit_mime_info_ref             (WebKitMimeInfo *info);
 
-WEBKIT_DEPRECATED void
+WEBKIT_API void
 webkit_mime_info_unref           (WebKitMimeInfo *info);
 
-WEBKIT_DEPRECATED const gchar *
+WEBKIT_API const gchar *
 webkit_mime_info_get_mime_type   (WebKitMimeInfo *info);
 
-WEBKIT_DEPRECATED const gchar *
+WEBKIT_API const gchar *
 webkit_mime_info_get_description (WebKitMimeInfo *info);
 
-WEBKIT_DEPRECATED const gchar * const *
+WEBKIT_API const gchar * const *
 webkit_mime_info_get_extensions  (WebKitMimeInfo *info);
 
 G_END_DECLS
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitPlugin.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitPlugin.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitPlugin.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitPlugin.h	2021-09-29 11:16:12.683267699 -0500
@@ -55,19 +55,19 @@ struct _WebKitPluginClass {
     void (*_webkit_reserved3) (void);
 };
 
-WEBKIT_DEPRECATED GType
+WEBKIT_API GType
 webkit_plugin_get_type           (void);
 
-WEBKIT_DEPRECATED const gchar *
+WEBKIT_API const gchar *
 webkit_plugin_get_name           (WebKitPlugin *plugin);
 
-WEBKIT_DEPRECATED const gchar *
+WEBKIT_API const gchar *
 webkit_plugin_get_description    (WebKitPlugin *plugin);
 
-WEBKIT_DEPRECATED const gchar *
+WEBKIT_API const gchar *
 webkit_plugin_get_path           (WebKitPlugin *plugin);
 
-WEBKIT_DEPRECATED GList *
+WEBKIT_API GList *
 webkit_plugin_get_mime_info_list (WebKitPlugin *plugin);
 
 G_END_DECLS
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitSettings.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitSettings.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitSettings.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitSettings.h	2021-09-29 11:16:12.683267699 -0500
@@ -147,10 +147,10 @@ WEBKIT_API void
 webkit_settings_set_enable_frame_flattening                    (WebKitSettings *settings,
                                                                 gboolean        enabled);
 
-WEBKIT_DEPRECATED gboolean
+WEBKIT_API gboolean
 webkit_settings_get_enable_plugins                             (WebKitSettings *settings);
 
-WEBKIT_DEPRECATED void
+WEBKIT_API void
 webkit_settings_set_enable_plugins                             (WebKitSettings *settings,
                                                                 gboolean        enabled);
 
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitWebContext.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitWebContext.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitWebContext.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitWebContext.h	2021-09-29 11:16:12.683267699 -0500
@@ -197,17 +197,17 @@ webkit_web_context_get_favicon_database_
 WEBKIT_API WebKitSecurityManager *
 webkit_web_context_get_security_manager             (WebKitWebContext              *context);
 
-WEBKIT_DEPRECATED void
+WEBKIT_API void
 webkit_web_context_set_additional_plugins_directory (WebKitWebContext              *context,
                                                      const gchar                   *directory);
 
-WEBKIT_DEPRECATED void
+WEBKIT_API void
 webkit_web_context_get_plugins                      (WebKitWebContext              *context,
                                                      GCancellable                  *cancellable,
                                                      GAsyncReadyCallback            callback,
                                                      gpointer                       user_data);
 
-WEBKIT_DEPRECATED GList *
+WEBKIT_API GList *
 webkit_web_context_get_plugins_finish               (WebKitWebContext              *context,
                                                      GAsyncResult                  *result,
                                                      GError                       **error);
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitWebsiteData.h webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitWebsiteData.h
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/API/gtk/WebKitWebsiteData.h	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/API/gtk/WebKitWebsiteData.h	2021-09-29 11:16:12.683267699 -0500
@@ -42,7 +42,7 @@ typedef struct _WebKitWebsiteData WebKit
  * @WEBKIT_WEBSITE_DATA_LOCAL_STORAGE: Local storage data.
  * @WEBKIT_WEBSITE_DATA_WEBSQL_DATABASES: WebSQL databases. Deprecated 2.24
  * @WEBKIT_WEBSITE_DATA_INDEXEDDB_DATABASES: IndexedDB databases.
- * @WEBKIT_WEBSITE_DATA_PLUGIN_DATA: Plugins data. Deprecated 2.32
+ * @WEBKIT_WEBSITE_DATA_PLUGIN_DATA: Plugins data.
  * @WEBKIT_WEBSITE_DATA_COOKIES: Cookies.
  * @WEBKIT_WEBSITE_DATA_DEVICE_ID_HASH_SALT: Hash salt used to generate the device ids used by webpages. Since 2.24
  * @WEBKIT_WEBSITE_DATA_HSTS_CACHE: HSTS cache. Since 2.26
diff -urpN webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/gtk/WebPageProxyGtk.cpp webkitgtk.2.34.0/Source/WebKit/UIProcess/gtk/WebPageProxyGtk.cpp
--- webkitgtk-2.34.0.orig/Source/WebKit/UIProcess/gtk/WebPageProxyGtk.cpp	2021-09-01 04:16:51.000000000 -0500
+++ webkitgtk.2.34.0/Source/WebKit/UIProcess/gtk/WebPageProxyGtk.cpp	2021-09-29 11:16:12.687267721 -0500
@@ -38,6 +38,10 @@
 #include <WebCore/PlatformDisplay.h>
 #include <wtf/NeverDestroyed.h>
 
+#if PLATFORM(X11) && ENABLE(NETSCAPE_PLUGIN_API)
+#include <gtk/gtkx.h>
+#endif
+
 namespace WebKit {
 
 void WebPageProxy::platformInitialize()
@@ -67,6 +71,62 @@ void WebPageProxy::didUpdateEditorState(
     pageClient().selectionDidChange();
 }
 
+#if PLATFORM(X11) && ENABLE(NETSCAPE_PLUGIN_API)
+typedef HashMap<uint64_t, GtkWidget* > PluginWindowMap;
+static PluginWindowMap& pluginWindowMap()
+{
+    static NeverDestroyed<PluginWindowMap> map;
+    return map;
+}
+
+static gboolean pluginContainerPlugRemoved(GtkSocket* socket)
+{
+    uint64_t windowID = static_cast<uint64_t>(gtk_socket_get_id(socket));
+    pluginWindowMap().remove(windowID);
+    return FALSE;
+}
+
+void WebPageProxy::createPluginContainer(CompletionHandler<void(uint64_t)>&& completionHandler)
+{
+    RELEASE_ASSERT(WebCore::PlatformDisplay::sharedDisplay().type() == WebCore::PlatformDisplay::Type::X11);
+    GtkWidget* socket = gtk_socket_new();
+    g_signal_connect(socket, "plug-removed", G_CALLBACK(pluginContainerPlugRemoved), 0);
+    gtk_container_add(GTK_CONTAINER(viewWidget()), socket);
+
+    uint64_t windowID = static_cast<uint64_t>(gtk_socket_get_id(GTK_SOCKET(socket)));
+    pluginWindowMap().set(windowID, socket);
+    completionHandler(windowID);
+}
+
+void WebPageProxy::windowedPluginGeometryDidChange(const WebCore::IntRect& frameRect, const WebCore::IntRect& clipRect, uint64_t windowID)
+{
+    GtkWidget* plugin = pluginWindowMap().get(windowID);
+    if (!plugin)
+        return;
+
+    if (gtk_widget_get_realized(plugin)) {
+        GdkRectangle clip = clipRect;
+        cairo_region_t* clipRegion = cairo_region_create_rectangle(&clip);
+        gdk_window_shape_combine_region(gtk_widget_get_window(plugin), clipRegion, 0, 0);
+        cairo_region_destroy(clipRegion);
+    }
+
+    webkitWebViewBaseChildMoveResize(WEBKIT_WEB_VIEW_BASE(viewWidget()), plugin, frameRect);
+}
+
+void WebPageProxy::windowedPluginVisibilityDidChange(bool isVisible, uint64_t windowID)
+{
+    GtkWidget* plugin = pluginWindowMap().get(windowID);
+    if (!plugin)
+        return;
+
+    if (isVisible)
+        gtk_widget_show(plugin);
+    else
+        gtk_widget_hide(plugin);
+}
+#endif // PLATFORM(X11) && ENABLE(NETSCAPE_PLUGIN_API)
+
 void WebPageProxy::setInputMethodState(std::optional<InputMethodState>&& state)
 {
     webkitWebViewBaseSetInputMethodState(WEBKIT_WEB_VIEW_BASE(viewWidget()), WTFMove(state));
